﻿#target bridge-3.0
if ( app.name == "bridge"  && app.version[0] == '3' )
//-----------------------------------------------------------------------
// 	This script was created by John Beardsworth www.beardsworth.co.uk
// 	Integrates iView Catalog Set xmp data with Lightroom 1.1
//
// 	NOT FOR PUBLIC RELEASE UNTIL LR1.1 IS PUBLIC
//
//    Version 1.3 Clean up - extra menu
// 	Version 1.4 Added about menu
// 	Version 1.5 Cleaned up separators
// 	Version 2.0 Switch to Expression Media
//--------------------------------------------------------------------


//USERS CAN EDIT THESE ITEMS
//var ivNamepace = "http://ns.iview-multimedia.com/mediapro/1.0/";
var ivNamepace = "http://ns.microsoft.com/expressionmedia/1.0/";
var ivAppName = "Expression Media 2";
var lrNamepace = "http://ns.adobe.com/lightroom/1.0/";


//used in functions convert_iViewLabel and convert_LrLabel
//to copy between LR and iView fields
//iView writes these values 
var iViewLabelArray = Array ("High", "7", "2", "3", "Normal") ;
//these should match the labels in Bridge > Preferences > Labels
var LrLabelArray = Array ("Red", "Yellow", "Green", "Blue", "Purple") ;


///////////////////////////////////////////////////////////////////////////
//DON'T EDIT ANYTHING AFTER HERE UNLESS YOU KNOW WHAT YOU'RE DOING
//OR UNLESS YOU HAVE DECIDED I DON'T KNOW WHAT I'M DOING....
///////////////////////////////////////////////////////////////////////////

var varAlert = ivAppName + "-Lightroom integration scripts by John Beardsworth\n\nVersion 2.0";
{
// Create main menu item
	if (MenuElement.find ('ivIntegration')) 
	MenuElement.remove("ivIntegration");
//	var iv_LR_separator =  new MenuElement("command", "-", "at the end of ivIntegration", "iv_LR_separator");
	var ivIntegration = new MenuElement( "menu", ivAppName + " - Lightroom integration",  "-at the end of Tools", "ivIntegration");

//-----------------------------------------------------------------------
//Add iView catalog sets as Lightroom keywords

if( MenuElement.find ("ivSets_to_LR_Keywords") ) 
MenuElement.remove("ivSets_to_LR_Keywords");
var ivSets_to_LR_Keywords =  new MenuElement("command", ivAppName + " data to LR hierarchical keywords", "at the end of ivIntegration", "ivSets_to_LR_Keywords");	

ivSets_to_LR_Keywords.onSelect  = function(){    
  var sels = app.document.selections;   
  for (var i = 0; i < sels.length; i++){

	//loop through the metadata, placing catalog sets and hierarchical keywords into arrays	
	var md = sels[i].synchronousMetadata;   
	md.namespace = ivNamepace;    
	var ivMediaSets = md.CatalogSets;
	var ivCustomFields = md.UserFields;
	var ivPeople = md.People;
	var ivEvent = md.Event;

	md.namespace = lrNamepace;
	//strip any existing catalog sets out of hierarchical keywords
	var lrHierarchicalKeywords = '';
		for (var j = 0; j < md.hierarchicalSubject.length; j++){
		if (md.hierarchicalSubject[j].substr(0,5) !="iView")
		lrHierarchicalKeywords += md.hierarchicalSubject[j] +';' ;
		}	
	
	//run through catalog sets 
	var ivMediaSetString = ";";
		for (var j = 0; j < ivMediaSets.length; j++){
		ivMediaSetString += "iView|Catalog Sets|" + ivMediaSets[j] + ";";
		}	

	//run through custom fields
	var ivCustomFieldsString = '';
		for (var j = 0; j < ivCustomFields.length; j++){
		ivCustomFieldsArray = ivCustomFields[j].split("=");
		ivCustomFieldValue =  ";iView|Custom Fields|" + ivCustomFieldsArray[0] + "|" + ivCustomFieldsArray[1];
		ivCustomFieldsString += ivCustomFieldValue ;	
		}	

	// iView People field
	var ivPeopleString = '';
		for (var j = 0; j < ivPeople.length; j++){
		ivPeopleString += ";iView|People|" + ivPeople[j];	
		}	

	// iView Event
	if(ivEvent)
	ivEvent =  ";iView|Event|" + ivEvent;

	//append to hierarchical keywords
	if (md.hierarchicalSubject.length >0)
	md.hierarchicalSubject = lrHierarchicalKeywords  + ivMediaSetString + ivCustomFieldsString + ivPeopleString + ivEvent;
	else
	md.hierarchicalSubject = ivMediaSetString + ivCustomFieldsString + ivPeopleString + ivEvent;
  }
}

//-----------------------------------------------------------------------
// get iView's labels to Lightrroom
if( MenuElement.find ("iv_LRlabels") ) 
MenuElement.remove("iv_LRlabels");
//var iv_LR_separator =  new MenuElement("command", "-", "at the end of ivIntegration", "iv_LR_separator");
var iv_LRlabels =  new MenuElement("command", "Push " + ivAppName  + " labels to Lightroom", "-at the end of ivIntegration", "iv_LRlabels");

iv_LRlabels.onSelect  = function(){    
  var sels = app.document.selections;   
  for (var i = 0; i < sels.length; i++){
	//loop through the metadata, placing catalog sets and hierarchical keywords into arrays	
	var md = sels[i].synchronousMetadata;   
	md.namespace ="http://ns.adobe.com/photoshop/1.0/";
	var ivLabel = convert_iViewLabel(md.Urgency) ;	
	md.namespace ="http://ns.adobe.com/xap/1.0/";
	md.Label = ivLabel;
	}
}



//-----------------------------------------------------------------------
// get Lightrroom's labels to iView
if( MenuElement.find ("lr_ivlabels") ) 
MenuElement.remove("lr_ivlabels");
var lr_ivlabels =  new MenuElement("command", "Push Lightroom labels to " + ivAppName , "at the end of ivIntegration", "lr_ivlabels");

lr_ivlabels.onSelect  = function(){    
  var sels = app.document.selections;   
  for (var i = 0; i < sels.length; i++){
	//loop through the metadata, placing catalog sets and hierarchical keywords into arrays	
	var md = sels[i].synchronousMetadata;   
	md.namespace ="http://ns.adobe.com/xap/1.0/";
	var lrLabel = convert_LrLabel(md.Label)	 ;	
	md.namespace ="http://ns.adobe.com/photoshop/1.0/";
	md.Urgency = lrLabel  ;
	}
}

//-----------------------------------------------------------------------
// get Lightrroom's labels to iView
if( MenuElement.find ("labelmapping") ) 
MenuElement.remove("labelmapping");
var labelmapping =  new MenuElement("command", "Show Lightroom and " + ivAppName + " mapping", "at the end of ivIntegration", "labelmapping");

labelmapping.onSelect  = function(){    
	//loop through the metadata, placing catalog sets and hierarchical keywords into arrays	
	labelmsg = "Lightroom label ... iView label (urgency field)" + "\n\n";
	labelmsg +=  LrLabelArray[0] + " ... " + iViewLabelArray[0] + "\n";
	labelmsg +=  LrLabelArray[1] + " ... " + iViewLabelArray[1] + "\n";
	labelmsg +=  LrLabelArray[2] + " ... " + iViewLabelArray[2] + "\n";
	labelmsg +=  LrLabelArray[3] + " ... " + iViewLabelArray[3] + "\n";
	labelmsg +=  LrLabelArray[4] + " ... " + iViewLabelArray[4] + "\n";
	labelmsg +=  "\n";
	labelmsg +=  "These values are set in the script's header." + "\n";
	labelmsg +=  "If you have changed the Adobe labels from the default, you will have to adjust the script's header." + "\n";
	alert(labelmsg);
}

//-----------------------------------------------------------------------
if( MenuElement.find ("menu_iv_Lr2") ) 
MenuElement.remove("menu_iv_Lr2");
var menu_iv_Lr2 =  new MenuElement("command", "Clear Lightroom hierarchical keywords", "-at the end of ivIntegration", "menu_iv_Lr2");

menu_iv_Lr2.onSelect  = function(){    
  var sels = app.document.selections;   
  for (var i = 0; i < sels.length; i++){
	//loop through the metadata, placing catalog sets and hierarchical keywords into arrays	
	var md = sels[i].synchronousMetadata;   
	md.namespace = lrNamepace;
	if (md.hierarchicalSubject != "")
	md.hierarchicalSubject ="" ;
	//md.hierarchicalSubject.remove;
  }
	alert("Cleared hierarchical keywords");
}

//-----------------------------------------------------------------------
if( MenuElement.find ("menu_iv_Lr3") ) 
MenuElement.remove("menu_iv_Lr3");
var menu_iv_Lr3 =  new MenuElement("command", "Clear " + ivAppName + " metadata (except labels)", "at the end of ivIntegration", "menu_iv_Lr3");

menu_iv_Lr3.onSelect  = function(){    
  var sels = app.document.selections;   
  for (var i = 0; i < sels.length; i++){

	//loop through the metadata, placing catalog sets and hierarchical keywords into arrays	
	var md = sels[i].synchronousMetadata;   
	md.namespace = ivNamepace;
	md.CatalogSets = "";
	md.People = "";
	md.UserFields = "";
	md.Event = "";
  }
}

//~ if( MenuElement.find ("menu_iv_Lr4") ) 
//~ MenuElement.remove("menu_iv_Lr4");
//~ var menu_iv_Lr4 =  new MenuElement("command", "Clear Expression Media metadata (except labels)", "at the end of ivIntegration", "menu_iv_Lr4");

//~ menu_iv_Lr4.onSelect  = function(){    
//~   var sels = app.document.selections;   
//~   for (var i = 0; i < sels.length; i++){

//~ 	//loop through the metadata, placing catalog sets and hierarchical keywords into arrays	
//~ 	var md = sels[i].synchronousMetadata;   
//~ 	md.namespace = "http://ns.microsoft.com/expressionmedia/1.0/";
//~ 	md.CatalogSets = "";
//~ 	md.People = "";
//~ 	md.UserFields = "";
//~ 	md.Event = "";
//~   }
//~ }

//-----------------------------------------------------------------------
//label conversion functions
if( MenuElement.find ("menu_iv_Lr5") ) 
MenuElement.remove("menu_iv_Lr5");
//var iv_LR_separator =  new MenuElement("command", "-", "at the end of ivIntegration", "iv_LR_separator");
var menu_iv_Lr5 =  new MenuElement("command", "About", "-at the end of ivIntegration", "menu_iv_Lr5");

menu_iv_Lr5.onSelect  = function(){    
  alert (varAlert);

}
//-----------------------------------------------------------------------
//label conversion functions
function convert_iViewLabel(ivValue){    		
		if( ivValue == iViewLabelArray[0])	
		return LrLabelArray[0] ;
		else if( ivValue == iViewLabelArray[1] )
		return LrLabelArray[1];
		else if( ivValue == iViewLabelArray[2] )
		return  LrLabelArray[2] ;
		else if( ivValue == iViewLabelArray[3] )
		return  LrLabelArray[3] ;
		else if( ivValue == iViewLabelArray[4 ] )
		return  LrLabelArray[4] ;
		else 
		return  "" ;
}

function convert_LrLabel(lrValue){    
		if( lrValue == LrLabelArray[0])	
		return 1 ;
		else if( lrValue== LrLabelArray[1] )
		return 7 ;
		else if( lrValue == LrLabelArray[2] )
		return  2 ;
		else if( lrValue == LrLabelArray[3] )
		return 3 ;
		else if( lrValue == LrLabelArray[4] )
		return 5 ;
		else 
		return  "" ;
}

//closing brace
}